#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <i86.h>
#include <dos.h>
#include "filefix.h"

int platdos_cntInt21 = 0;
int platdos_cntInt21_eax[256];
int platdos_cntInt21_ebx[256];
int platdos_cntInt21_ecx[256];
int platdos_cntInt21_edx[256];

void (__interrupt * platdos_oldInt21) (void) = NULL;

extern void __interrupt newInt21 (void);

static int getIVect (void (__interrupt ** oldInt) (void), int intNo) {
int retVal = 0;
	__asm {
		mov		eax, 0204h
		mov		ebx, intNo
		int		31h
		mov		eax, oldInt
		jc		skipWrite
		mov		[eax], edx
		mov		[eax+4], cx
		skipWrite:
		sbb		eax, eax
		mov		retVal, eax
	}
	return retVal;
}

static int setIVect (void (__interrupt * oldInt) (void), int intNo) {
int retVal = 0;
	__asm {
		mov		eax, 0205h
		mov		ebx, intNo
		mov		edx, oldInt[0]
		mov		cx, oldInt[4]
		int		31h
		sbb		eax, eax
		mov		retVal, eax
	}
	return retVal;
}

int GetMSWin9XVer (void) {
int retval = 0;
    _asm {
		mov		eax, 0x1600
		int		0x2f
		test	al, 0x7f
		jz      NotWin
		ror		ax, 8
		movzx	eax, ax
		jmp     End
	  NotWin:
		xor		eax, eax
	  End:
		mov		retval, eax
    }

    return retval;
}

#if 0
int GetDosVer (void) {
int retval;

    _asm {
		mov	eax, 0x3306
		int	0x21
		shl	ebx, 16
		mov	bx, dx
		mov	retval, ebx
    }

    return retval;
}

static int verNT = -2;

/*
 * Returns WINNT_HOST if the system is running under Win NT/2K/XP.
 */
int InMSWindowsNT (void) {
int DOSVer;
    DOSVer = GetDosVer() >> 16;
    if (DOSVer == WINNT_HOST) {	/* Windows NT */
		verNT = DOSVer;
		return verNT;
    }

    verNT = 0;
    return verNT;					/* Not Windows */
}
#endif

static int ver9X = -2;

/*
 * Returns a non-zero value if the system is running under Win 9X.
 */
int InMSWindows9X (void) {
int Win9XVer;
    if (ver9X != -2) return ver9X;

    Win9XVer = GetMSWin9XVer();
    if (Win9XVer) {
		ver9X = Win9XVer;
		return ver9X;			/* Windows 3.x/9X */
    }

    ver9X = 0;
    return ver9X;				/* Not Windows */
}

/*
 * Remove the substituted interrupt 21 vector
 */
static void returnInt21 (void) {
	if (platdos_oldInt21 != NULL) setIVect (platdos_oldInt21, 0x21);
}

/*
 * Warning, this function calls atexit, thereby consuming one of the 32
 * slots that are guaranteed to be available.
 */
int fixInt21 (void) {
int ret;
	if (!InMSWindows9X ()) return 0;
	ret = getIVect (&platdos_oldInt21, 0x21) || setIVect (&newInt21, 0x21);
	if (ret == 0) ret |= atexit (returnInt21);
	return ret;
}

#ifdef FILE_FIX_CLI_TEST

extern int platdos_cntInt21;
extern int platdos_cntInt21_eax[256];
extern int platdos_cntInt21_ebx[256];
extern int platdos_cntInt21_ecx[256];
extern int platdos_cntInt21_edx[256];

void dump () {
int eax[256], ebx[256], ecx[256], edx[256];
int i, c;

	c = platdos_cntInt21;
    for (i=0; i < 256; i++) {
        eax[i] = platdos_cntInt21_eax[i];
        ebx[i] = platdos_cntInt21_ebx[i];
        ecx[i] = platdos_cntInt21_ecx[i];
        edx[i] = platdos_cntInt21_edx[i];
    }

    printf ("%8s %8s %8s %8s\n", "eax", "ebx", "ecx", "edx");
    for (i=0; i < c; i++) {
        printf ("%08X %08X %08X %08X\n", eax[i], ebx[i], ecx[i], edx[i]);
    }
	printf ("cntInt21   = %d\n", c);
}

int main (int argc, char * argv[]) {
FILE * fp;

	printf ("%d\n", fixInt21 ());

	if (argc > 1) {
		fp = fopen (argv[1], "wb");
		fprintf (fp, "test");
		dump ();
		if (fp != NULL) fclose (fp);
	}

	return 0;
}

#endif
